/*
 * Copyright 2006-2007 Tom Adams
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.googlecode.instinct.internal.reflect;

import com.googlecode.instinct.internal.lang.FieldValueSpec;
import com.googlecode.instinct.internal.lang.MethodSpec;
import java.lang.reflect.Constructor;
import java.lang.reflect.Method;

public final class ReflectMasterImpl implements ReflectMaster {
    private final ReflectObjectMaster objectMaster = new ReflectObjectMasterImpl();
    private final ReflectMethodMaster methodMaster = new ReflectMethodMasterImpl();
    private final ReflectFieldMaster fieldMaster = new ReflectFieldMasterImpl();

    public <T> Constructor<T> getConstructor(final Class<T> cls) {
        return objectMaster.getConstructor(cls);
    }

    public <T> Method getMethod(final Class<T> cls, final MethodSpec method) {
        return methodMaster.getMethod(cls, method);
    }

    public FieldValueSpec[] getInstanceFields(final Object ref) {
        return fieldMaster.getInstanceFields(ref);
    }
}
